      PROGRAM MCLARS
      IMPLICIT  NONE

      REAL*8    QSQ,WSTART,WSTOP,WSTEP
      INTEGER   NPAR,N,IRAND,I,ISWITCH,J

      PARAMETER ( NPAR      = 17     )
      PARAMETER ( N         = 1      ) ! Number of M.C. events
      PARAMETER ( ISWITCH   = 0      ) ! Chooses random number generator
      PARAMETER ( QSQ       = 1.279  ) ! GeV^2
      PARAMETER ( WSTART    = 1.075  ) ! GeV
      PARAMETER ( WSTOP     = 2.000  ) ! GeV
      PARAMETER ( WSTEP     = 0.010  ) ! GeV

      REAL*8    GET_RAND,A1A2FIT,U1,U2,T1,PI
      REAL*8    AR(4,4),   WR(4,4),  GR(4,4),  BB(4,4),  AA(4)
      REAL*8    EAR(4,4), EWR(4,4), EGR(4,4), EBB(4,4), EAA(4)
      REAL*8    PARS1(NPAR),PARS1_INIT(NPAR)
      REAL*8    PARS2(NPAR),PARS2_INIT(NPAR)
      REAL*8    EPARS1(NPAR),EPARS1_INIT(NPAR)
      REAL*8    EPARS2(NPAR),EPARS2_INIT(NPAR)
      REAL*8    WGEV,delta,r2,r3,r4,dis,err,A1

      COMMON/RANDOM/IRAND
      COMMON/FITPARS/AR,WR,GR,BB,AA,PARS1,PARS2,PARS1_INIT,PARS2_INIT

      !----------------------------------------------------------------

      PI    = ACOS(-1.)
      IRAND = ISWITCH


      OPEN(2,FILE='input/a1_fitpars',STATUS='old')
      OPEN(3,FILE='input/a2_fitpars',STATUS='old')
      DO J=1,NPAR
        READ(2,*) PARS1_INIT(J),EPARS1_INIT(J)
        PARS1(J)  =  PARS1_INIT(J)
        EPARS1(J) = EPARS1_INIT(J)

        READ(3,*) PARS2_INIT(J),EPARS2_INIT(J)
        PARS2(J)  =  PARS2_INIT(J)
        EPARS2(J) = EPARS2_INIT(J)

      ENDDO
      CLOSE(2)
      CLOSE(3)
      !----------------------------------------------------------------

      CALL INITIALIZE_RAND()

      OPEN (21,FILE='output/mc.out',STATUS='UNKNOWN')

      DO WGEV = WSTART,WSTOP,WSTEP
      
        DO I = 1,1000
          U1 = GET_RAND(I+1)                    ! Random # from 0-1
          U2 = GET_RAND(I+2)
         !T1 = SQRT(-2.*LOG(U1))*COS(2.*PI*U2)  ! Gaussian dist.
          T1 =  2.*(U1-0.5)                     ! Random dist -1 to 1

          DO J=1,4
            AR(J,1) = PARS1(J)
            AR(J,2) = PARS2(J)
            WR(J,1) = PARS1(J+4)
            WR(J,2) = PARS2(J+4)
            GR(J,1) = PARS1(J+8)
            GR(J,2) = PARS2(J+8)
            BB(J,1) = PARS1(J+12)
            BB(J,2) = PARS2(J+12)
          ENDDO
          AA(1)     = PARS1(17)
          AA(2)     = PARS2(17)

          AR(1,1) = PARS1(1)+ EPARS1(1) *T1
          A1      = A1A2FIT(WGEV,QSQ,1,4,4,delta,r2,r3,r4,dis,err)
          WRITE(21,*) WGEV,A1
        ENDDO 
      ENDDO
      CLOSE(21)
      END


******************************************************************************
      SUBROUTINE INITIALIZE_RAND()
      COMMON/RANDOM/IRAND
      INTEGER IRAND

      INTEGER nseed
      INTEGER today(3), now(3)
      REAL rndm                 ! random number generator must link to CERN libs
      REAL tmp

      CHARACTER(8)   DATE
      CHARACTER(10)  TIME
      CHARACTER(5)   ZONE
      INTEGER        VALUES(8)


      IF(IRAND.EQ.0) THEN  ! Using "rndm".  Whatever the seed, always get same sequence.
        call idate(today)                                    
        call itime(now)
        nseed = today(2)+today(1)+now(1)+now(2)+now(3)    ! select a seed for rand
        tmp   = rndm(nseed)

      ELSEIF(IRAND.EQ.1) THEN
        CALL DATE_AND_TIME(DATE,TIME,ZONE,VALUES)
        NSEED = VALUES(7)+VALUES(8)
        CALL SRAND(NSEED)
      ELSE
       STOP "PROBLEM"
      ENDIF

      RETURN
      END


      FUNCTION GET_RAND(I)
      INTEGER I,IRAND

      COMMON/RANDOM/IRAND

      ! RNDM is from CERNLIB, but is now obsolete. It is useful here for debugging 
      !      since it *always* generates the identical sequence of numbers.
      ! RAND is a built-in gnufortran (g77) function. It's not very robust, and there
      !      are many more powerful new CERNLIB routines.  Probably ok for our purposes
      !      here though.


      IF(IRAND.EQ.0) THEN
        GET_RAND = RNDM(I)
      ELSE
        GET_RAND  = RAND(0)
      ENDIF

      END

